Attribute VB_Name = "SLE_Gen"
' This file was automatically generated by scanning
' source files:
'
'C:\GenSLE\UDP_test\server\UDPtest.sle
'   udpcode.bas
'
' This module requires the support routines from
' the automatically generated file SLE_User.bas,
' as well as the forms SLE_Edit.frm and SLE_Pick.frm
' and the code module SLE_Lib.bas from the GenSLE
' code system.
'
Public DSQty as Long
'
Public Enum SLEtypes
    sle_SD
    sle_DS
End Enum
'
Public Const sle_TypeQty As Integer =  2 
Public sle_TypeList(sle_TypeQty - 1) As String
'
Function LoadSD(APath as String) as String
    SD.UDPenabled = False
    SD.UDPserver = False
    SD.TXautoMsg = False
    On Error GoTo LFail
    fr% = FreeFile
    Open APath For Input As #fr%
    On Error GoTo 0
    While Not EOF(fr%)
        Line Input #fr%, x$
        Select Case DKey(x$)
        Case "UDPENABLED"
            SD.UDPenabled = True
        Case "UDPSERVER"
            SD.UDPserver = True
        Case "MYIP"
            SD.MyIP = DData(x$)
        Case "EXTIP"
            SD.ExtIP = DData(x$)
        Case "PORT"
            SD.Port = longVal(DData(x$))
        Case "TXINTERVAL"
            SD.TXinterval = longVal(DData(x$))
        Case "TXAUTOMSG"
            SD.TXautoMsg = True
        End Select
    Wend
    Close fr%
    LoadSD = ""
    Exit Function
Lfail:
    Close fr%
    LoadSD = "Could Not Open " + APath + "."
End Function

Sub SaveSD(APath as String)
    fr% = FreeFile
    Open APath For Output As #fr%
    If SD.UDPenabled Then Print #fr%,"UDPENABLED
    If SD.UDPserver Then Print #fr%,"UDPSERVER
    If SD.MyIP <> "" Then Print #fr%,"MYIP"; vbTab; SD.MyIP
    If SD.ExtIP <> "" Then Print #fr%,"EXTIP"; vbTab; SD.ExtIP
    If SD.Port <> 0 Then Print #fr%,"PORT"; vbTab; SD.Port
    If SD.TXinterval <> 0 Then Print #fr%,"TXINTERVAL"; vbTab; SD.TXinterval
    If SD.TXautoMsg Then Print #fr%,"TXAUTOMSG
    Close #fr%
End Sub

Function LoadDS(APath as String) as String
    ReDim DS(100)
    DSQty = 0
    P& = -1
    On Error GoTo LFail
    fr% = FreeFile
    Open APath For Input As #fr%
    On Error GoTo 0
    While Not EOF(fr%)
        Line Input #fr%, x$
        If DKey(x$) = "LABEL" Then
            'Key
            DS(DSQty).Label = DData(x$)
            P& = DSQty
            DSQty = P& + 1
            If P& >= UBound(DS) Then
                ReDim Preserve DS(UBound(DS) * 2)
            End If
        ElseIf P& >= 0 Then
            Select Case DKey(x$)
            Case "DATA"
                DS(P&).Data = LongVal(DData(x$))
            End Select
        End If
    Wend
    Close fr%
    LoadDS = ""
    Exit Function
Lfail:
    Close fr%
    LoadDS = "Could Not Open " + APath + "."
End Function

Sub SaveDS(APath as String)
    fr% = FreeFile
    Open APath For Output As #fr%
    If DSQty > 0 Then
        For P& = 0 to DSQty - 1
            If DS(P&).Label <> "" Then
                Print #fr%,"LABEL"; vbTab; DS(P&).Label
                If DS(P&).Data <> 0 Then Print #fr%,"DATA"; vbTab; DS(P&).Data
            End If
        Next
    End If
    Close #fr%
End Sub

Sub OnAnyPick(Action as String)
    Select Case EditMode
    Case sle_DS
        Call OnPickDS(Action)
    End Select
End Sub

Sub OnCancelAnyPick()
    Select Case EditMode
    Case sle_DS
        Call OnCancelPickDS()
    End Select
End Sub

Sub OnAnyEdit(Action as String)
    Select Case EditMode
    Case sle_SD
        Select Case Action
        Case "Save"
            Call OnSaveSD()
        Case "Quit"
            Call OnCancelEditSD()
        Case Else
            Call OnEditSD(Action)
        End Select
    Case sle_DS
        Select Case Action
        Case "Save"
            Call OnSaveDS()
        Case "Quit"
            Call OnCancelEditDS()
        Case "Delete"
            Call OnDeleteDS()
        Case Else
            Call OnEditDS(Action)
        End Select
    End Select
End Sub

Function KeySLE(FullKey as String, IX as sle_IndexSet) As String
    Dim Key as KeyParts
    Key = ParseKey(FullKey)
    If Key.Type = "" Then
        KeySLE = SKnoTypeKey(Key.Key, Key.Fmt)
        If KeySLE <> "" Then Exit Function
        Key.Type = Key.Key
        Key.Key = ""
    End If
    Select Case Key.Type
    Case "SD"
        KeySLE = KeySD(Key.Key, Key.Fmt)
    Case "DS"
        KeySLE = KeyDS(Key.Key, IX.DS, Key.ID, Key.Fmt)
    Case Else
        KeySLE = ""
    End Select
End Function

Function KeyDataByLoc(FullKey as String, _
                      DS_Loc as Long) As String
    Dim IX as sle_IndexSet
    IX.DS = DS_Loc
    KeyDataByLoc = KeyData(FullKey, IX)
End Function

'
Sub EditSD(ParamArray Actions() As Variant)
    EditMode = sle_SD
    Call StartEditing
    If Ubound(Actions) < 0 Then
        Call EditSetupSD
    Else
        Call EditSetupSD(Actions)
    End If
    Call PopEditSD(SD)
End Sub

Function AskAbandonSDChanges() As Boolean
    If MsgBox("Abandon Changes to System Setup" + "?", vbYesNo, "Confirm Abandon") = vbYes Then
        AskAbandonSDChanges = True
    Else
        AskAbandonSDChanges = False
    End If
End Function

Sub EditSetupSD(ParamArray Actions() As Variant)
    Dim AAR() As Variant, NA As Variant
    '
    ReDim TBXref( 4 )
    Call PlaceInit
    Call ClearEditMenu
    AAR = Actions
    If UBound(Actions) = 0 Then
        If IsArray(Actions(0)) Then
            AAR = Actions(0)
        End If
    End If
    i% = 0
    If UBound(AAR) < 0 Then
        Call DefaultEditMenu
    Else
        For Each NA in AAR()
            Call AddEditMenu(i%, CStr(AAR(i%)))
            i% = i% + 1
        Next
    End If
    '
    i% = AddCtrl()
    CtrlData(i%).CtrlIndex = AddChk()
    SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).Style =  4 
    SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Caption = "UDP Enabled"
    '
    i% = AddCtrl()
    CtrlData(i%).CtrlIndex = AddChk()
    SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).Style =  4 
    SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Caption = "UDP Server"
    '
    i% = AddCtrl()
    CtrlData(i%).Style =  7 
    CtrlData(i%).LblIndex = AddLbl()
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = ""
    '
    i% = AddCtrl()
    CtrlData(i%).Ctrlindex = AddTB()
    TBXref(CtrlData(i%).CtrlIndex) = i%
    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).LblIndex = AddLbl()
    CtrlData(i%).Style =  5 
    CtrlData(i%).ZeroValid = False
    CtrlData(i%).Enabled = True
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = "My IP:   "
    CtrlData(i%).DShare = True
    '
    i% = AddCtrl()
    CtrlData(i%).Ctrlindex = AddTB()
    TBXref(CtrlData(i%).CtrlIndex) = i%
    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).LblIndex = AddLbl()
    CtrlData(i%).Style =  5 
    CtrlData(i%).ZeroValid = False
    CtrlData(i%).Enabled = True
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = "Other IP:"
    CtrlData(i%).DShare = True
    '
    i% = AddCtrl()
    CtrlData(i%).Ctrlindex = AddTB()
    TBXref(CtrlData(i%).CtrlIndex) = i%
    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).LblIndex = AddLbl()
    CtrlData(i%).Style =  1 
    CtrlData(i%).ZeroValid = False
    CtrlData(i%).Enabled = True
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = "Port:    "
    CtrlData(i%).DShare = True
    '
    i% = AddCtrl()
    CtrlData(i%).Style =  7 
    CtrlData(i%).LblIndex = AddLbl()
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = ""
    '
    i% = AddCtrl()
    CtrlData(i%).Ctrlindex = AddTB()
    TBXref(CtrlData(i%).CtrlIndex) = i%
    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).LblIndex = AddLbl()
    CtrlData(i%).Style =  1 
    CtrlData(i%).ZeroValid = False
    CtrlData(i%).Enabled = True
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = "Auto Interval:"
    CtrlData(i%).DShare = True
    '
    i% = AddCtrl()
    CtrlData(i%).CtrlIndex = AddChk()
    SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).Style =  4 
    SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Caption = "TX Auto Time: "
    '
    SLE_Edit.ActCMD(0).TabIndex = i% + 1
    SLE_Edit.ActCMD(1).TabIndex = i% + 2
    SLE_Edit.ActCMD(2).TabIndex = i% + 3
    SLE_Edit.vs.TabIndex = i% + 4
    '
    Call LocateCtrls
    Call PlaceCtrls
    '
End Sub

Sub PopEditSD(PD As One_System_Setup)
    '
    If PD.UDPenabled Then
        SLE_Edit.EditChk(CtrlData( 0 ).CtrlIndex).Value = 1
    Else
        SLE_Edit.EditChk(CtrlData( 0 ).CtrlIndex).Value = 0
    End If
    If PD.UDPserver Then
        SLE_Edit.EditChk(CtrlData( 1 ).CtrlIndex).Value = 1
    Else
        SLE_Edit.EditChk(CtrlData( 1 ).CtrlIndex).Value = 0
    End If
    SLE_Edit.EditTB(CtrlData( 3 ).CtrlIndex).Text = PD.MyIP
    SLE_Edit.EditTB(CtrlData( 4 ).CtrlIndex).Text = PD.ExtIP
    SLE_Edit.EditTB(CtrlData( 5 ).CtrlIndex).Text = Strip$(Str$(PD.Port))
    SLE_Edit.EditTB(CtrlData( 7 ).CtrlIndex).Text = Strip$(Str$(PD.TXinterval))
    If PD.TXautoMsg Then
        SLE_Edit.EditChk(CtrlData( 8 ).CtrlIndex).Value = 1
    Else
        SLE_Edit.EditChk(CtrlData( 8 ).CtrlIndex).Value = 0
    End If
    '
    Call ShowSLE_Edit
    SLE_Edit.Caption = "Editing System Setup
    SLE_Edit.EditChk(0).SetFocus
    '
End Sub

Function ReadEditSD() As One_System_Setup
    '
    ReadEditSD.UDPenabled = (SLE_Edit.EditChk(CtrlData( 0 ).CtrlIndex).Value = 1)
    ReadEditSD.UDPserver = (SLE_Edit.EditChk(CtrlData( 1 ).CtrlIndex).Value = 1)
    ReadEditSD.MyIP =     SLE_Edit.EditTB(CtrlData( 3 ).CtrlIndex).Text
    ReadEditSD.ExtIP =     SLE_Edit.EditTB(CtrlData( 4 ).CtrlIndex).Text
    ReadEditSD.Port =     LongVal(SLE_Edit.EditTB(CtrlData( 5 ).CtrlIndex).Text)
    ReadEditSD.TXinterval =     LongVal(SLE_Edit.EditTB(CtrlData( 7 ).CtrlIndex).Text)
    ReadEditSD.TXautoMsg = (SLE_Edit.EditChk(CtrlData( 8 ).CtrlIndex).Value = 1)
    '
End Function

Function IsSDChanged(PD As One_System_Setup) As Boolean
    '
    IsSDChanged = True
    '
    If PD.UDPenabled Xor (SLE_Edit.EditChk(CtrlData( 0 ).CtrlIndex).Value = 1) _
        Then Exit Function
    If PD.UDPserver Xor (SLE_Edit.EditChk(CtrlData( 1 ).CtrlIndex).Value = 1) _
        Then Exit Function
    If PD.MyIP <> SLE_Edit.EditTB(CtrlData( 3 ).CtrlIndex).Text _
        Then Exit Function
    If PD.ExtIP <> SLE_Edit.EditTB(CtrlData( 4 ).CtrlIndex).Text _
        Then Exit Function
    If PD.Port <>     LongVal(SLE_Edit.EditTB(CtrlData( 5 ).CtrlIndex).Text) _
        Then Exit Function
    If PD.TXinterval <>     LongVal(SLE_Edit.EditTB(CtrlData( 7 ).CtrlIndex).Text) _
        Then Exit Function
    If PD.TXautoMsg Xor (SLE_Edit.EditChk(CtrlData( 8 ).CtrlIndex).Value = 1) _
        Then Exit Function
    '
    IsSDChanged = False
    '
End Function

Function KeySD(Key as String, KeyFmt As String)
    Select Case Key
    Case "UDPENABLED"
        KeySD = SKboolFmt(SD.UDPenabled, KeyFmt)
    Case "UDPSERVER"
        KeySD = SKboolFmt(SD.UDPserver, KeyFmt)
    Case "MYIP"
        KeySD = SKstrFmt(SD.MyIP, KeyFmt)
    Case "EXTIP"
        KeySD = SKstrFmt(SD.ExtIP, KeyFmt)
    Case "PORT"
        KeySD = SKlongFmt(SD.Port, KeyFmt)
    Case "TXINTERVAL"
        KeySD = SKlongFmt(SD.TXinterval, KeyFmt)
    Case "TXAUTOMSG"
        KeySD = SKboolFmt(SD.TXautoMsg, KeyFmt)
    Case "MYHOSTNAME"
        KeySD = SKstrFmt(SD.MyHostName, KeyFmt)
    Case "MYTRUEIP"
        KeySD = SKstrFmt(SD.MyTrueIP, KeyFmt)
    Case "SOCKHANDLE"
        KeySD = SKintFmt(SD.SockHandle, KeyFmt)
    Case Else
        KeySD = SKstrFmt(Key, KeyFmt)
    End Select
End Function

Sub PickDS(ParamArray Actions() As Variant)
    Dim NA As Variant
    '
    Load SLE_Pick
    For i% = 0 To SLE_Pick.menuAct.Ubound
        if i% > 0 Then SLE_Pick.menuAct(i%).Visible = False
    Next
    If UBound(actions) < 0 Then
        SLE_Pick.menuAct(0).Visible = True
        SLE_Pick.menuAct(0).Caption = "&Edit"
        if 1 > SLE_Pick.menuAct.Ubound Then Load SLE_Pick.menuAct(1)
        SLE_Pick.menuAct(1).Visible = True
        SLE_Pick.menuAct(1).Caption = "&New"
        if 2 > SLE_Pick.menuAct.Ubound Then Load SLE_Pick.menuAct(2)
        SLE_Pick.menuAct(2).Visible = True
        SLE_Pick.menuAct(2).Caption = "&Find"
    Else
        i% = 0
        For Each NA in Actions()
            if i% > SLE_Pick.menuAct.Ubound Then Load SLE_Pick.menuAct(i%)
            SLE_Pick.menuAct(i%).Visible = True
            SLE_Pick.menuAct(i%).Caption = Actions(i%)
            i% = i% + 1
        Next
    End If
    '
    SLE_Pick.HeadLBL.Caption = PickDSHeader()
    '
    SLE_Pick.LB.Clear
    If DSQty > 0 Then
        For p& = 0 To DSQty - 1
            If DS(p&).Label <> "" Then
                SLE_Pick.LB.AddItem(PickDSLine(p&))
                SLE_Pick.LB.ItemData(SLE_Pick.LB.NewIndex) = p&
            End If
        Next
    End If
    '
    EditMode = sle_DS
    EditSaveNeeded = False
    Call StartEditing
    SLE_Pick.Caption = "Pick Set:"
    Call ShowSLE_Pick
    SLE_Pick.LB.SetFocus
    '
End Sub

Function RePickDS(Loc As Long)
    x$ = PickDSLine(Loc)
    If SLE_Pick.LB.ListCount > 0 Then
        For i% = 0 to SLE_Pick.LB.ListCount - 1
            If SLE_Pick.LB.ItemData(i%) = Loc Then
                If x$ <> "" Then
                    RePickDS = Loc
                    SLE_Pick.LB.List(i%) = x$
                Else
                    RePickDS = -1
                    SLE_Pick.LB.RemoveItem i%
                End If
                Exit Function
            End If
        Next
    End If
    If x$ <> "" Then
        SLE_Pick.LB.AddItem(PickDSLine(Loc))
        RePickDS = SLE_Pick.LB.NewIndex
        SLE_Pick.LB.ItemData(RePickDS) = Loc
    End If
End Function

Function PickDSLine(PI as Long) As String
    PickDSLine = ""
    If DS(PI).Label = "" Then Exit Function
End Function

Function AskDeleteDS(DelLoc as Long)
    If MsgBox("Delete Set " + DS(DelLoc).Label + "?", vbYesNo, "Confirm Delete") = vbYes Then
        AskDeleteDS = True
    Else
        AskDeleteDS = False
    End If
End Function

Function AskAbandonDSChanges() As Boolean
    If MsgBox("Abandon Changes to Set" + " " + DS(EditLoc).Label + "?", vbYesNo, "Confirm Abandon") = vbYes Then
        AskAbandonDSChanges = True
    Else
        AskAbandonDSChanges = False
    End If
End Function

Function AskNewDS() As Long
    AskNewDS = -1
    p$ = "New Set Label"
    t$ = "New Set"
    x$ = InputBox(p$+":", t$)
    If StrPtr(x$) = 0 Then Exit Function
    If Trim$(x$) = "" Then Exit Function
    If FindDS(x$) >= 0 Then
        MsgBox "Set Label Already Exists.", vbOKOnly, t$
    Else
        AskNewDS = NewDS(x$)
        EditSaveNeeded = True
    End If
End Function

Function AskFindDS() As Long
    AskFindDS = -1
    p$ = "Find Set Label"
    t$ = "Find Set"
    x$ = InputBox(p$+":", t$)
    If StrPtr(x$) = 0 Then Exit Function
    If Trim$(x$) = "" Then Exit Function
    AskFindDS = FindDS(x$)
End Function

Function FindDS(IDV As String) as Long
    FindDS = -1
    If DSQty = 0 Then Exit Function
    x$ = Trim$(Ucase$(IDV))
    If x$ = "" Then Exit Function
    For P& = 0 to DSQty - 1
        If Trim$(Ucase$(DS(P&).Label)) = x$ Then
            FindDS = P&
            Exit For
        End If
    Next
End Function

Function NewDS(IDV As String) as Long
    '
    NewDS = -1
    If DSQty > 0 Then
        For P& = 0 to DSQty - 1
            If DS(P&).Label = "" Then
                NewDS = P&
                Exit For
            End If
        Next
    End If
    If NewDS < 0 Then
        NewDS = DSQty
        DSQty = DSQty + 1
        If DSQty > UBound(DS) Then
            ReDim Preserve DS(UBound(DS) * 2)
        End If
    End If
    '
    DS(NewDS).Label = Trim$(Ucase$(IDV))
    DS(NewDS).Data = 0
    '
End Function

Function SortDS() as Long()
    '
    Dim Z() As Long
    If DSQty = 0 Then
        Redim Z(0)
        Z(0) = -1
        SortDS = Z
        Exit Function
    End If
    '
    ReDim Z(DSQty - 1)
    For P& = 0 to DSQty - 1
        If Trim$(Ucase$(DS(P&).Label)) = "" Then
            Z(P&) = -1
        Else
            Z(P&) = P&
        End If
    Next
    '
    If DSQty > 1 Then
        swp% = -1
        While swp% <> 0
            swp% = 0
            For P& = 0 to DSQty - 2
                If Z(P& + 1) = -1 Then
                    'do nothing
                ElseIf Z(P&) = -1 Then
                    'swap invalid to end
                    Z(P&) = Z(P& + 1)
                    Z(P& + 1) = -1
                    swp% = -1
                Else
                    'compare
                    If DS(Z(P&)).Label > DS(Z(P& + 1)).Label Then                        'swap
                        T& = Z(P&)
                        Z(P&) = Z(P& + 1)
                        Z(P& + 1) = T&
                        swp% = -1
                    End If
                End If
            Next
        Wend
    End If
    SortDS = Z
    '
End Function

Sub EditSetupDS(ParamArray Actions() As Variant)
    Dim AAR() As Variant, NA As Variant
    '
    ReDim TBXref( 2 )
    Call PlaceInit
    Call ClearEditMenu
    AAR = Actions
    If UBound(Actions) = 0 Then
        If IsArray(Actions(0)) Then
            AAR = Actions(0)
        End If
    End If
    i% = 0
    If UBound(AAR) < 0 Then
        Call DefaultEditMenu
        Call DefaultDeleteMenu
    Else
        For Each NA in AAR()
            Call AddEditMenu(i%, CStr(AAR(i%)))
            i% = i% + 1
        Next
    End If
    '
    i% = AddCtrl()
    CtrlData(i%).Ctrlindex = AddTB()
    TBXref(CtrlData(i%).CtrlIndex) = i%
    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).LblIndex = AddLbl()
    CtrlData(i%).Style =  5 
    CtrlData(i%).ZeroValid = False
    CtrlData(i%).Enabled = False
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = "Label"
    '
    i% = AddCtrl()
    CtrlData(i%).Ctrlindex = AddTB()
    TBXref(CtrlData(i%).CtrlIndex) = i%
    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).TabIndex = i%
    CtrlData(i%).LblIndex = AddLbl()
    CtrlData(i%).Style =  1 
    CtrlData(i%).ZeroValid = False
    CtrlData(i%).Enabled = True
    SLE_Edit.EditLbl(CtrlData(i%).LblIndex).Caption = "Data"
    '
    SLE_Edit.ActCMD(0).TabIndex = i% + 1
    SLE_Edit.ActCMD(1).TabIndex = i% + 2
    SLE_Edit.ActCMD(2).TabIndex = i% + 3
    SLE_Edit.vs.TabIndex = i% + 4
    '
    Call LocateCtrls
    Call PlaceCtrls
    '
End Sub

Sub PopEditDS(PD As One_Set)
    '
    SLE_Edit.EditTB(CtrlData( 0 ).CtrlIndex).Text = PD.Label
    SLE_Edit.EditTB(CtrlData( 1 ).CtrlIndex).Text = Strip$(Str$(PD.Data))
    '
    Call ShowSLE_Edit
    SLE_Edit.Caption = "Editing Set Label " + PD.Label + ":"
    SLE_Edit.EditTB(1).SetFocus
    '
End Sub

Function ReadEditDS() As One_Set
    '
    ReadEditDS.Label =     SLE_Edit.EditTB(CtrlData( 0 ).CtrlIndex).Text
    ReadEditDS.Data =     LongVal(SLE_Edit.EditTB(CtrlData( 1 ).CtrlIndex).Text)
    '
End Function

Function IsDSChanged(PD As One_Set) As Boolean
    '
    IsDSChanged = True
    '
    If PD.Label <> SLE_Edit.EditTB(CtrlData( 0 ).CtrlIndex).Text _
        Then Exit Function
    If PD.Data <>     LongVal(SLE_Edit.EditTB(CtrlData( 1 ).CtrlIndex).Text) _
        Then Exit Function
    '
    IsDSChanged = False
    '
End Function

Function KeyDS(Key as String, DefaultLoc As Long, KeyID As String, KeyFmt As String)
    Dim Loc as Long
    Loc = DefaultLoc
    If KeyID <> "" Then Loc = FindDS(KeyID)
    If Loc < 0 Then Exit Function
    Select Case Key
    Case "LABEL"
        KeyDS = SKstrFmt(DS(Loc).Label, KeyFmt)
    Case "DATA"
        KeyDS = SKlongFmt(DS(Loc).Data, KeyFmt)
    Case Else
        KeyDS = SKstrFmt(Key, KeyFmt)
    End Select
End Function

