Attribute VB_Name = "SLE_Lib"
' Code module support for the GenSLE runtime
'
' Data structures used to maintain the Edit form
'
' Master field data structure
'
Public Type OneCtrlField
    CtrlIndex As Integer
    LblIndex As Integer
    Fmt As String
    Cols As Integer
    Lines As Integer
    LShare As Boolean
    DShare As Boolean
    ZeroValid As Boolean
    Style As Integer
    Enabled As Boolean
    '
    CtrlWidth As Integer
    CtrlHeight As Integer
    LblWidth As Integer
    PlaceWidth As Integer
    AbsLblTop As Integer
    AbsLblLeft As Integer
    AbsCtrlLeft As Integer
    AbsCtrlTop As Integer
    '
End Type

Public Enum OCFStyle
    v_integer
    v_long
    v_single
    v_double
    v_boolean
    v_string
    v_multi
    v_label
End Enum

Public CtrlData() As OneCtrlField
Public CtrlQty As Integer

'indeces into CtrlData() by control array
'
Public LblXref() As Integer
Public TBXref() As Integer
Public MultiXref() As Integer
Public ChkXref() As Integer

'control array controls loaded
'
Public LblLoaded As Integer
Public TBloaded As Integer
Public MultiLoaded As Integer
Public ChkLoaded As Integer
'
'control array controls in current use
'
Public LblUsed As Integer
Public TBused As Integer
Public MultiUsed As Integer
Public ChkUsed As Integer
'
Public SaveTop As Integer
'
Public FormHeight As Integer
Public FormTop As Integer   'realtime scrolling top position

Public EditMode As Integer  'OCFStyle of current edit
Public EditLoc As Long      'index of array entry for SLE_Edit
Public EditLBline As Long   'index into listbox control from Pick
Public EditSaveNeeded As Boolean

Public Type OneType
    FormWidth As Integer
    FormLeft As Integer
    FormHeight As Integer
    FormTop As Integer
    PickWidth As Integer
    PickLeft As Integer
    PickHeight As Integer
    PickTop As Integer
End Type
'
Public TypeData() As OneType

Public Const sle_Multi_EndTag As String = "|SLE_MULTI_END"
Public KeyNestLevel As Integer
Public KeyIX As sle_IndexSet
Public Type KeyParts
    Type As String
    ID As String
    Key As String
    Fmt As String
End Type

'
' Declares for implementing the semi-modal shell
'
Private Const WAIT_INFINITE = -1&
Private Const WAIT_TIMEOUT = &H102
Private Const SYNCHRONIZE = &H100000

Private Declare Function OpenProcess Lib "kernel32" _
  (ByVal dwDesiredAccess As Long, _
   ByVal bInheritHandle As Long, _
   ByVal dwProcessId As Long) As Long
   
Private Declare Function WaitForSingleObject Lib "kernel32" _
  (ByVal hHandle As Long, _
   ByVal dwMilliseconds As Long) As Long
   
Private Declare Function CloseHandle Lib "kernel32" _
  (ByVal hObject As Long) As Long

'These declarations needed by IsRunning() API calls:
'
Declare Function GetWindow Lib "user32" _
    (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Declare Function GetParent Lib "user32" _
    (ByVal hWnd As Long) As Long
Declare Function GetWindowTextLength Lib "user32" _
    Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Declare Function GetWindowText Lib "user32" _
    Alias "GetWindowTextA" (ByVal hWnd As Long, _
    ByVal lpString As String, ByVal cch As Long) As Long
Declare Function ShowWindow Lib "user32" _
    (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Declare Function ShowWindowAsync Lib "user32" _
    (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Declare Function SetWindowPos Lib "user32" _
    (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, _
    ByVal X As Long, ByVal y As Long, ByVal cx As Long, _
    ByVal cy As Long, ByVal wFlags As Long) As Long
'
Const GW_HWNDFIRST = 0
Const GW_HWNDNEXT = 2
Const SW_Normal = 1
Const SW_Maximize = 3
Const SW_Restore = 9
Const HWND_TOP = 0
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2
Const conHwndTopmost = -1
Const conHwndNoTopmost = -2
Const conSwpNoActivate = &H10
Const conSwpShowWindow = &H40
Const SWP_NOMOVE = &H2
Const SWP_NOSIZE = &H1

Public Function IsRunning(Title As String, CurrWnd As Long) As Boolean
    'Returns true if the given app is running, else false
    'if the app is running, pops it up and gives it
    'the focus
    Dim Length As Long
    Dim TaskName As String
    Dim Parent As Long
    Dim temphwnd As Long
    Dim tx As Long
    '
    While CurrWnd <> 0
        Parent = GetParent(CurrWnd)
        Length = GetWindowTextLength(CurrWnd)
        TaskName = Space$(Length + 1)
        Length = GetWindowText(CurrWnd, TaskName, Length + 1)
        TaskName = Left$(TaskName, Len(TaskName) - 1)
        If Length > 0 Then
            If TaskName = Title Then
                X = ShowWindowAsync(CurrWnd, SW_Restore)
                SetWindowPos CurrWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
                AppActivate TaskName
                SetWindowPos CurrWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
                IsRunning = True
                Exit Function
            End If
        End If
        CurrWnd = GetWindow(CurrWnd, GW_HWNDNEXT)
    Wend
    IsRunning = False
    '
End Function

Function ModalShell(ShellCmd As String) As Long
    tid& = Shell(ShellCmd, vbHide)
    ModalShell = OpenProcess(SYNCHRONIZE, True, tid&)
End Function

Function ModalShellFinished(ShellID As Long) As Boolean
    r& = WaitForSingleObject(ShellID, 10)
    If r& = WAIT_TIMEOUT Then
        ModalShellFinished = False
    Else
        ModalShellFinished = True
    End If
End Function

Function ParseKey(FullKey As String) As KeyParts
    '
    ' Legal key syntax for fullkey:
    ' {key}          generally non-GenSLE data
    ' {type}         {type,fmt}          uses default field
    ' {type.key}     {type.key,fmt}      uses default index
    ' {type(id).key} {type(id).key,fmt}  overrides index
    '
    X$ = FullKey
    '
    ParseKey.ID = "" 'default
    i% = InStr(X$, "(")
    If i% > 0 Then
        j% = InStr(X$, ")")
        If j% > 0 Then
            ParseKey.ID = Mid$(X$, i% + 1, j% - i% - 1)
            X$ = Left$(X$, i% - 1) + Right$(X$, Len(X$) - j%)
        End If
    End If
    '
    i% = InStr(X$, ",")
    If i% > 0 Then
        ParseKey.Fmt = Right$(X$, Len(X$) - i%)
        X$ = Trim$(UCase$(Left$(X$, i% - 1)))
    Else
        ParseKey.Fmt = ""
        X$ = Trim$(UCase$(X$))
    End If
    '
    i% = InStr(X$, ".")
    If i% > 0 Then
        ParseKey.Key = Right$(X$, Len(X$) - i%)
        ParseKey.Type = Left$(X$, i% - 1)
    Else
        ParseKey.Key = X$
        ParseKey.Type = ""
    End If
    '
End Function

Function DKey(dataline As String) As String
    i% = InStr(dataline, vbTab)
    If i% = 0 Then i% = InStr(dataline, ",")
    If i% = 0 Then i% = InStr(dataline, "=")
    If i% > 0 Then
        DKey = UCase$(Left$(dataline, i% - 1))
    Else
        DKey = UCase$(dataline)
    End If
End Function

Function DData(dataline As String) As String
    i% = InStr(dataline, vbTab)
    If i% = 0 Then i% = InStr(dataline, ",")
    If i% = 0 Then i% = InStr(dataline, "=")
    If i% > 0 Then
        DData = Right$(dataline, Len(dataline) - i%)
    Else
        DData = ""
    End If
End Function

Function GetCRLFline(Src As String, LN As Integer) As String
    Dim X() As String
    'Extract zero based line # LN from
    'CRLF-delimited multiline Src string
    X = Split(Src, vbCrLf)
    If LN > UBound(X) Then
        GetCRLFline = ""
    Else
        GetCRLFline = X(LN)
    End If
End Function

Function IntVal(a$) As Integer
    On Error GoTo OOPS
    IntVal = Int(a$)
    Exit Function
OOPS:
    IntVal = 0
    Exit Function
End Function

Function LongVal(a$) As Long
    On Error GoTo OOPS
    LongVal = Val(a$)
    Exit Function
OOPS:
    LongVal = 0
    Exit Function
End Function

Function SingleVal(a$) As Single
    On Error GoTo OOPS
    SingleVal = Val(a$)
    Exit Function
OOPS:
    SingleVal = 0
    Exit Function
End Function

Function DoubleVal(a$) As Double
    On Error GoTo OOPS
    DoubleVal = Val(a$)
    Exit Function
OOPS:
    DoubleVal = 0
    Exit Function
End Function

Function MultiHeight(TLines As Integer) As Long
    If TLines <= 1 Then
        MultiHeight = SLE_Edit.EditTB(0).Height
    Else
        X$ = "Hj"
        For i% = 1 To TLines - 1
            X$ = X$ + vbCrLf + "Hj"
        Next
        MultiHeight = SLE_Edit.EditTB(0).Height + SLE_Edit.TextHeight(X$)
    End If
End Function

Function AddMultiTag(X$) As String
    'sanity check to make sure data doesn't include duplicate end tag
    i% = InStr(X$, vbCrLf + sle_Multi_EndTag)
    If i% = 0 Then
        AddMultiTag = X$ + vbCrLf + sle_Multi_EndTag
    Else
        AddMultiTag = Left$(X$, i% - 1)
    End If
End Function

Function LoadMulti(fr%) As String
    LoadMulti = ""
LMmore:
    If EOF(fr%) Then Exit Function
    Line Input #fr%, X$
    If X$ <> sle_Multi_EndTag Then
        If LoadMulti <> "" Then X$ = vbCrLf + X$
        LoadMulti = LoadMulti + X$
        GoTo LMmore
    End If
End Function

Function Strip$(X$)
    Strip$ = Trim$(X$)
    If Val(X$) = 0 Then Strip$ = ""
End Function

Function StripAmp(X$)
    i% = InStr(X$, "&")
    While i% > 0
        X$ = Left$(X$, i% - 1) + Right$(X$, Len(X$) - i%)
        i% = InStr(X$, "&")
    Wend
    StripAmp = X$
End Function

Sub PlaceInit()
    '
    Load SLE_Edit
    CtrlQty = 0
    FormTop = 0
    '
    LblUsed = 0
    TBused = 0
    MultiUsed = 0
    ChkUsed = 0
    '
    If LblLoaded > 0 Then
        For i% = 0 To LblLoaded - 1
            SLE_Edit.EditLBL(i%).Visible = False
        Next
    End If
    If TBloaded > 0 Then
        For i% = 0 To TBloaded - 1
            SLE_Edit.EditTB(i%).Visible = False
        Next
    End If
    If MultiLoaded > 0 Then
        For i% = 0 To MultiLoaded - 1
            SLE_Edit.MultiTB(i%).Visible = False
        Next
    End If
    If ChkLoaded > 0 Then
        For i% = 0 To ChkLoaded - 1
            SLE_Edit.EditChk(i%).Visible = False
        Next
    End If
    '
End Sub

Function AddCtrl() As Integer
    AddCtrl = CtrlQty
    On Error GoTo OOPS
    If AddCtrl > UBound(CtrlData()) Then
FRD:
        ReDim Preserve CtrlData(AddCtrl + 10)
    End If
    On Error GoTo 0
    CtrlData(AddCtrl).Fmt = ""
    CtrlData(AddCtrl).Cols = 0
    CtrlData(AddCtrl).Lines = 0
    CtrlData(AddCtrl).LShare = False
    CtrlData(AddCtrl).DShare = False
    CtrlQty = CtrlQty + 1
    Exit Function
OOPS:
    Resume FRD
End Function

Function AddLbl() As Integer
    'note that labels do not have their own ctrldata() entries
    AddLbl = LblUsed
    LblUsed = LblUsed + 1
    While LblUsed > LblLoaded
        If LblLoaded > 0 Then Load SLE_Edit.EditLBL(LblLoaded)
        LblLoaded = LblLoaded + 1
    Wend
    SLE_Edit.EditLBL(AddLbl).Height = SLE_Edit.TextHeight("Hj") * 1.2
    SLE_Edit.EditLBL(AddLbl).ForeColor = &H400000
    SLE_Edit.EditLBL(AddLbl).Visible = True
End Function

Function AddTB() As Integer
    TBused = TBused + 1
    While TBused > TBloaded
        If TBloaded > 0 Then Load SLE_Edit.EditTB(TBloaded)
        TBloaded = TBloaded + 1
    Wend
    AddTB = TBused - 1
    SLE_Edit.EditTB(AddTB).Height = SLE_Edit.TextHeight("Hj") * 1.5
    SLE_Edit.EditTB(AddTB).Visible = True
    SLE_Edit.EditTB(AddTB).Enabled = True
End Function

Function AddMulti() As Integer
    MultiUsed = MultiUsed + 1
    While MultiUsed > MultiLoaded
        If MultiLoaded > 0 Then Load SLE_Edit.MultiTB(MultiLoaded)
        MultiLoaded = MultiLoaded + 1
    Wend
    AddMulti = MultiUsed - 1
    SLE_Edit.MultiTB(AddMulti).Visible = True
End Function

Function AddChk() As Integer
    ChkUsed = ChkUsed + 1
    While ChkUsed > ChkLoaded
        Load SLE_Edit.EditChk(ChkLoaded)
        ChkLoaded = ChkLoaded + 1
    Wend
    AddChk = ChkUsed - 1
    SLE_Edit.EditChk(AddChk).Visible = True
End Function

Sub LocateCtrls()
    'assuming EditSetupX has set up the descriptors,
    'determine where to put the controls on form init.
    'EditSetupX calls this routine automatically.
    '
    If CtrlQty = 0 Then
        FormHeight = T% + lsp%
        Exit Sub
    End If
    txh% = SLE_Edit.TextHeight("Hj")    'height of 1 line
    txw% = SLE_Edit.TextWidth("0")      'width of 1 char
    lsp% = SLE_Edit.EditTB(0).Height - txh%    'inter-line spacing
    lsh% = txh% + lsp%                  '1-line control spacing
    lsl% = SLE_Edit.EditLBL(0).Height
    '
    ncx% = 120  'next control x
    ncy% = 120  'next control y
    nly% = 0    'next LINE y
    '
    For i% = 0 To CtrlQty - 1
        Select Case CtrlData(i%).Style
        Case v_label
            CtrlData(i%).AbsLblLeft = 120
            CtrlData(i%).AbsLblTop = nly%
            CtrlData(i%).LblWidth = Len(SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Caption) * txw%
            ncx% = 120
            ncy% = nly% + lsl%
            nly% = ncy%
        Case v_multi
            'multiline text box can't share
            CtrlData(i%).AbsLblLeft = 120
            CtrlData(i%).AbsLblTop = nly%
            CtrlData(i%).LblWidth = Len(SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Caption) * txw%
            CtrlData(i%).AbsCtrlLeft = 120
            CtrlData(i%).AbsCtrlTop = nly% + lsl%
            CtrlData(i%).CtrlHeight = CtrlData(i%).Lines * txh% + txh% / 2
            CtrlData(i%).CtrlWidth = 0 'always stretches horizontally
            nly% = CtrlData(i%).AbsCtrlTop + CtrlData(i%).CtrlHeight + lsp%
            ncx% = 120
            ncy% = nly%
        Case v_boolean
            'checkbox
            CtrlData(i%).AbsLblTop = 0 'chkbox needs no label
            If CtrlData(i%).Cols = 0 Then
                CtrlData(i%).CtrlWidth = 0
            Else
                CtrlData(i%).CtrlWidth = CtrlData(i%).Cols * txw% + 400
            End If
            CtrlData(i%).PlaceWidth = Len(SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Caption) * txw% + 400
            CtrlData(i%).AbsCtrlLeft = ncx%
            'checkboxes don't need labels
            CtrlData(i%).AbsLblTop = 0
            CtrlData(i%).AbsCtrlTop = ncy%
            'set next line only if it's not already further up
            If ncy% + lsh% + 30 > nly% Then nly% = ncy% + lsh% + 30
            If CtrlData(i%).LShare And CtrlData(i%).CtrlWidth > 0 Then
                'prepare to share line w/next control
                ncx% = ncx% + CtrlData(i%).PlaceWidth + lsh%
            Else
                'go to next line
                ncx% = 120
                ncy% = nly%
            End If
        Case Else
            '1-line label + 1-line textbox
            CtrlData(i%).LblWidth = Len(SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Caption) * txw%
            If CtrlData(i%).DShare Then
                CtrlData(i%).AbsLblTop = ncy% + 30
                CtrlData(i%).AbsLblLeft = ncx%
                CtrlData(i%).AbsCtrlTop = ncy%
                CtrlData(i%).AbsCtrlLeft = ncx% + CtrlData(i%).LblWidth + 120
                If CtrlData(i%).Cols = 0 Then
                    CtrlData(i%).CtrlWidth = 0
                    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).MaxLength = 0
                Else
                    CtrlData(i%).CtrlWidth = CtrlData(i%).Cols * txw% + 120
                    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).MaxLength = CtrlData(i%).Cols
                    CtrlData(i%).PlaceWidth = CtrlData(i%).LblWidth + CtrlData(i%).CtrlWidth
                End If
                'set next line only if it's not already further up
                If ncy% + lsh% + lsp% > nly% Then nly% = ncy% + lsh% + lsp%
                If CtrlData(i%).LShare And CtrlData(i%).CtrlWidth > 0 Then
                    'prepare to share line w/next control
                    ncx% = ncx% + CtrlData(i%).PlaceWidth + lsh%
                Else
                    'go to next line
                    ncx% = 120
                    ncy% = nly%
                End If
            Else
                CtrlData(i%).AbsLblTop = ncy%
                CtrlData(i%).AbsLblLeft = ncx%
                CtrlData(i%).AbsCtrlTop = ncy% + lsl%
                CtrlData(i%).AbsCtrlLeft = ncx%
                If CtrlData(i%).Cols = 0 Then
                    CtrlData(i%).CtrlWidth = 0
                    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).MaxLength = 0
                Else
                    CtrlData(i%).CtrlWidth = CtrlData(i%).Cols * txw% + 120
                    SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).MaxLength = CtrlData(i%).Cols
                    CtrlData(i%).PlaceWidth = CtrlData(i%).LblWidth
                    If CtrlData(i%).PlaceWidth < CtrlData(i%).CtrlWidth Then
                        CtrlData(i%).PlaceWidth = CtrlData(i%).CtrlWidth
                    End If
                End If
                'set next line only if it's not already further up
                If ncy% + lsh% + lsl% + lsp% > nly% Then nly% = ncy% + lsh% + lsl% + lsp%
                If CtrlData(i%).LShare And CtrlData(i%).CtrlWidth > 0 Then
                    'prepare to share line w/next control
                    ncx% = ncx% + CtrlData(i%).PlaceWidth + lsh%
                Else
                    'go to next line
                    ncx% = 120
                    ncy% = nly%
                End If
            End If
        End Select
    Next
    SaveTop = nly%
    FormHeight = nly% + SLE_Edit.ActCMD(0).Height + 120
    '
End Sub

Sub PlaceCtrls()
    'Given that LocateCtrls has done its thing, this
    'actually places the controls after a scroll
    'change or resize.
    '
    'take no action if form has been minimized
    '
    If SLE_Edit.ScaleWidth = 0 Or SLE_Edit.ScaleHeight = 0 Then Exit Sub
    '
    'set up the scroll bar
    '
    fw% = SLE_Edit.ScaleWidth - 120
    If SLE_Edit.ScaleHeight < FormHeight Then
        fw% = fw% - SLE_Edit.VS.Width
        SLE_Edit.VS.Visible = True
        SLE_Edit.VS.Height = SLE_Edit.ScaleHeight
        SLE_Edit.VS.Left = SLE_Edit.ScaleWidth - SLE_Edit.VS.Width
        SLE_Edit.VS.Min = 0
        SLE_Edit.VS.Max = FormHeight - SLE_Edit.ScaleHeight
        SLE_Edit.VS.Value = FormTop
        SLE_Edit.VS.SmallChange = SLE_Edit.TextHeight("Hj")
        SLE_Edit.VS.LargeChange = SLE_Edit.ScaleHeight
    Else
        SLE_Edit.VS.Visible = False
    End If
    '
    If CtrlQty = 0 Then Exit Sub
    '
    For i% = 0 To CtrlQty - 1
        Select Case CtrlData(i%).Style
        Case v_label
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Top = CtrlData(i%).AbsLblTop - FormTop
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Left = CtrlData(i%).AbsLblLeft
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Width = CtrlData(i%).LblWidth
        Case v_multi
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Top = CtrlData(i%).AbsLblTop - FormTop
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Left = CtrlData(i%).AbsLblLeft
            SLE_Edit.MultiTB(CtrlData(i%).CtrlIndex).Top = CtrlData(i%).AbsCtrlTop - FormTop
            SLE_Edit.MultiTB(CtrlData(i%).CtrlIndex).Left = CtrlData(i%).AbsCtrlLeft
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Width = CtrlData(i%).LblWidth
            If CtrlData(i%).CtrlWidth > 0 Then
                SLE_Edit.MultiTB(CtrlData(i%).CtrlIndex).Width = CtrlData(i%).CtrlWidth
            Else
                W% = fw% - CtrlData(i%).AbsCtrlLeft
                If W% < 120 Then W% = 120
                SLE_Edit.MultiTB(CtrlData(i%).CtrlIndex).Width = W%
            End If
            SLE_Edit.MultiTB(CtrlData(i%).CtrlIndex).Height = CtrlData(i%).CtrlHeight
        Case v_boolean
            SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Top = CtrlData(i%).AbsCtrlTop - FormTop
            SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Left = CtrlData(i%).AbsCtrlLeft
            If CtrlData(i%).CtrlWidth > 0 Then
                SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Width = CtrlData(i%).CtrlWidth
            Else
                W% = fw% - CtrlData(i%).AbsCtrlLeft
                If W% < 120 Then W% = 120
                SLE_Edit.EditChk(CtrlData(i%).CtrlIndex).Width = W%
            End If
        Case Else
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Top = CtrlData(i%).AbsLblTop - FormTop
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Left = CtrlData(i%).AbsLblLeft
            SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).Top = CtrlData(i%).AbsCtrlTop - FormTop
            SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).Left = CtrlData(i%).AbsCtrlLeft
            SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).Enabled = CtrlData(i%).Enabled
            SLE_Edit.EditLBL(CtrlData(i%).LblIndex).Width = CtrlData(i%).LblWidth
            If CtrlData(i%).CtrlWidth > 0 Then
                SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).Width = CtrlData(i%).CtrlWidth
            Else
                W% = fw% - CtrlData(i%).AbsCtrlLeft
                If W% < 120 Then W% = 120
                SLE_Edit.EditTB(CtrlData(i%).CtrlIndex).Width = W%
            End If
        End Select
    Next
    '
    q% = -1
    If SLE_Edit.ScaleHeight > FormHeight Then
        If CtrlData(CtrlQty - 1).Style = v_multi Then
            SLE_Edit.ActCMD(0).Top = SLE_Edit.ScaleHeight - 120 - SLE_Edit.ActCMD(0).Height
            SLE_Edit.ActCMD(1).Top = SLE_Edit.ScaleHeight - 120 - SLE_Edit.ActCMD(0).Height
            SLE_Edit.ActCMD(2).Top = SLE_Edit.ScaleHeight - 120 - SLE_Edit.ActCMD(0).Height
            SLE_Edit.MultiTB(CtrlData(CtrlQty - 1).CtrlIndex).Height = SLE_Edit.ActCMD(0).Top - CtrlData(CtrlQty - 1).AbsCtrlTop - 120
            q% = 0
        End If
    End If
    If q% Then
        SLE_Edit.ActCMD(0).Top = SaveTop - FormTop
        SLE_Edit.ActCMD(1).Top = SaveTop - FormTop
        SLE_Edit.ActCMD(2).Top = SaveTop - FormTop
    End If
    W% = fw% - SLE_Edit.ActCMD(2).Width - 120
    If W% < SLE_Edit.ActCMD(1).Left + SLE_Edit.ActCMD(1).Width + 120 Then W% = SLE_Edit.ActCMD(1).Left + SLE_Edit.ActCMD(1).Width + 120
    SLE_Edit.ActCMD(2).Left = W%
    '
End Sub

Sub HideSLE_Edit()
    TypeData(EditMode).FormHeight = SLE_Edit.Height
    TypeData(EditMode).FormTop = SLE_Edit.Top
    TypeData(EditMode).FormWidth = SLE_Edit.Width
    TypeData(EditMode).FormLeft = SLE_Edit.Left
    SLE_Edit.Hide
End Sub

Sub ShowSLE_Edit()
    If TypeData(EditMode).FormHeight > 0 Then SLE_Edit.Height = TypeData(EditMode).FormHeight
    If TypeData(EditMode).FormTop > 0 Then SLE_Edit.Top = TypeData(EditMode).FormTop
    If TypeData(EditMode).FormWidth > 0 Then SLE_Edit.Width = TypeData(EditMode).FormWidth
    If TypeData(EditMode).FormLeft > 0 Then SLE_Edit.Left = TypeData(EditMode).FormLeft
    SLE_Edit.Show
End Sub

Sub HideSLE_Pick()
    TypeData(EditMode).PickHeight = SLE_Pick.Height
    TypeData(EditMode).PickTop = SLE_Pick.Top
    TypeData(EditMode).PickWidth = SLE_Pick.Width
    TypeData(EditMode).PickLeft = SLE_Pick.Left
    SLE_Pick.Hide
End Sub

Sub DisableSLE_Pick()
    TypeData(EditMode).PickHeight = SLE_Pick.Height
    TypeData(EditMode).PickTop = SLE_Pick.Top
    TypeData(EditMode).PickWidth = SLE_Pick.Width
    TypeData(EditMode).PickLeft = SLE_Pick.Left
    SLE_Pick.Enabled = False
End Sub

Sub ShowSLE_Pick()
    SLE_Pick.Enabled = True
    If TypeData(EditMode).PickHeight > 0 Then SLE_Pick.Height = TypeData(EditMode).PickHeight
    If TypeData(EditMode).PickTop > 0 Then SLE_Pick.Top = TypeData(EditMode).PickTop
    If TypeData(EditMode).PickWidth > 0 Then SLE_Pick.Width = TypeData(EditMode).PickWidth
    If TypeData(EditMode).PickLeft > 0 Then SLE_Pick.Left = TypeData(EditMode).PickLeft
    SLE_Pick.Show
End Sub

Function ParseSLEUI(X$) As Boolean
    ParseSLEUI = False
    y$ = DKey(X$)
    For i% = 0 To sle_TypeQty - 1
        If InStr(y$, UCase$(sle_TypeList(i%))) = 1 Then
            y$ = Right$(y$, Len(y$) - Len(sle_TypeList(i%)))
            If Len(y$) = 3 Then
                If Left$(y$, 1) = "_" Then
                    Select Case Mid$(y$, 2, 1)
                    Case "E"
                        Select Case Right$(y$, 1)
                        Case "H"
                            TypeData(i%).FormHeight = IntVal(DData(X$))
                            ParseSLEUI = True
                        Case "W"
                            TypeData(i%).FormWidth = IntVal(DData(X$))
                            ParseSLEUI = True
                        Case "T"
                            TypeData(i%).FormTop = IntVal(DData(X$))
                            ParseSLEUI = True
                        Case "L"
                            TypeData(i%).FormLeft = IntVal(DData(X$))
                            ParseSLEUI = True
                        End Select
                    Case "P"
                        Select Case Right$(y$, 1)
                        Case "H"
                            TypeData(i%).PickHeight = IntVal(DData(X$))
                            ParseSLEUI = True
                        Case "W"
                            TypeData(i%).PickWidth = IntVal(DData(X$))
                            ParseSLEUI = True
                        Case "T"
                            TypeData(i%).PickTop = IntVal(DData(X$))
                            ParseSLEUI = True
                        Case "L"
                            TypeData(i%).PickLeft = IntVal(DData(X$))
                            ParseSLEUI = True
                        End Select
                    End Select
                End If
            End If
        End If
    Next
End Function
            
Sub WriteSLEUI(DF As Integer)
    If sle_TypeQty = 0 Then Exit Sub
    For i% = 0 To sle_TypeQty - 1
        If TypeData(i%).FormWidth > 0 Then _
            Print #DF, sle_TypeList(i%); "_EW"; vbTab; TypeData(i%).FormWidth
        If TypeData(i%).FormLeft > 0 Then _
            Print #DF, sle_TypeList(i%); "_EL"; vbTab; TypeData(i%).FormLeft
        If TypeData(i%).FormHeight > 0 Then _
            Print #DF, sle_TypeList(i%); "_EH"; vbTab; TypeData(i%).FormHeight
        If TypeData(i%).FormTop > 0 Then _
            Print #DF, sle_TypeList(i%); "_ET"; vbTab; TypeData(i%).FormTop
        If TypeData(i%).PickWidth > 0 Then _
            Print #DF, sle_TypeList(i%); "_PW"; vbTab; TypeData(i%).PickWidth
        If TypeData(i%).PickLeft > 0 Then _
            Print #DF, sle_TypeList(i%); "_PL"; vbTab; TypeData(i%).PickLeft
        If TypeData(i%).PickHeight > 0 Then _
            Print #DF, sle_TypeList(i%); "_PH"; vbTab; TypeData(i%).PickHeight
        If TypeData(i%).PickTop > 0 Then _
            Print #DF, sle_TypeList(i%); "_PT"; vbTab; TypeData(i%).PickTop
    Next
End Sub

Function SKnoTypeKey(k$, X$) As String
    'RKey for generic simple things not data dependent
    Select Case UCase$(k$)
    Case "NULL"
        SKnoTypeKey = ""
    Case "FF"
        SKnoTypeKey = Chr$(12)
    Case "CHR"
        If IsNumeric(X$) Then
            N = Val(X$) And 255
            SKnoTypeKey = Chr$(N)
        Else
            SKnoTypeKey = ""
        End If
    Case "CR"
        SKnoTypeKey = vbCr
    Case "CRLF"
        SKnoTypeKey = vbCrLf
    Case "TAB"
        SKnoTypeKey = vbTab
    Case "LBRACE"
        SKnoTypeKey = "{"
    Case "RBRACE"
        SKnoTypeKey = "}"
    Case "TIME"
        SKnoTypeKey = Format$(Now, "hh:mm AM/PM")
    Case "DATE"
        SKnoTypeKey = Format$(Now, "mm/dd/yyyy")
    Case Else
        SKnoTypeKey = ""
    End Select
End Function

Function SKintFmt(KD As Integer, Fmt As String) As String
    X$ = Fmt
    If X$ <> "" Then
        If UCase$(Left$(X$, 1)) = "Z" Then
            lpad$ = "0000000000"
            X$ = Right$(X$, Len(X$) - 1)
        Else
            lpad$ = "          "
        End If
    End If
    If X$ <> "" Then
        W% = SingleVal(X$)
        If W% > 10 Then W% = 10
        If W% < 0 Then W% = 0
        SKintFmt = Right$(lpad$ + Trim$(Str$(KD)), W%)
    Else
        SKintFmt = Trim$(Str$(KD))
    End If
End Function

Function SKlongFmt(KD As Long, Fmt As String) As String
    If Fmt <> "" Then
        W% = SingleVal(Fmt)
        If W% > 10 Then W% = 10
        If W% < 0 Then W% = 0
        SKlongFmt = Right$("          " + Str$(KD), W%)
    Else
        SKlongFmt = Trim$(Str$(KD))
    End If
End Function

Function SKsingleFmt(KD As Single, Fmt As String) As String
    If Fmt <> "" Then
        j% = InStr(Fmt, ".")
        If j% > 0 Then
            k% = IntVal(Right$(Fmt, Len(Fmt) - j%))
            If k% > 0 And k% < 20 Then
                X$ = "#0." + String$(k%, "0")
            Else
                X$ = "#0"
            End If
            k% = IntVal(Left$(Fmt, j% - 1))
            If k% > 0 And k% <= 20 Then
                SKsingleFmt = Right$("                    " + Format$(KD, X$), k%)
            Else
                SKsingleFmt = Format$(KD, X$)
            End If
        Else
            W% = IntVal(Fmt)
            If W% > 10 Then W% = 10
            If W% < 0 Then W% = 0
            SKsingleFmt = Right$("          " + Str$(KD), W%)
        End If
    Else
        SKsingleFmt = Trim$(Str$(KD))
    End If
End Function

Function SKdoubleFmt(KD As Double, Fmt As String) As String
    If Fmt <> "" Then
        j% = InStr(Fmt, ".")
        If j% > 0 Then
            k% = IntVal(Right$(Fmt, Len(Fmt) - j%))
            If k% > 0 And k% < 20 Then
                X$ = "#0." + String$(k%, "0")
            Else
                X$ = "#0"
            End If
            k% = IntVal(Left$(Fmt, j% - 1))
            If k% < 0 Then k% = 0
            If k% > 20 Then k% = 20
            SKdoubleFmt = Right$("                    " + Format$(KD, X$), k%)
        Else
            W% = IntVal(Fmt)
            If W% > 20 Then W% = 20
            If W% < 0 Then W% = 0
            SKdoubleFmt = Right$("                    " + Str$(KD), W%)
        End If
    Else
        SKdoubleFmt = Trim$(Str$(KD))
    End If
End Function

Function SKstrFmt(KD As String, Fmt As String) As String
    If Fmt <> "" Then
        W% = IntVal(Fmt)
        If W% >= 0 Then
            SKstrFmt = Left$(KD + Space$(W%), W%)
        Else
            SKstrFmt = Right$(Space$(-W%) + KD, -W%)
        End If
    Else
        SKstrFmt = KD
    End If
End Function

Function SKmultiFmt(KD As String, Fmt As String) As String
    If Fmt <> "" Then
        j% = InStr(Fmt, ".")
        If j% > 0 Then
            'line dot width
            k% = IntVal(Left$(Fmt, j% - 1)) - 1
            W% = IntVal(Right$(Fmt, Len(Fmt) - j%))
            SKmultiFmt = Left$(GetCRLFline(KD, k%) + Space$(W%), W%)
        Else
            'line only
            W% = IntVal(Fmt) - 1
            SKmultiFmt = GetCRLFline(KD, W%)
        End If
    Else
        'use whole thing, extract keys
        SKmultiFmt = KeyData(KD, KeyIX, True)
    End If
End Function

Function SKboolFmt(KD As Boolean, Fmt As String) As String
    X$ = ULtoSPC(Fmt)
    j% = InStr(X$, ".")
    If j% > 0 Then
        If KD Then
            SKboolFmt = Left$(X$, j% - 1)
        Else
            SKboolFmt = Right$(X$, Len(X$) - j%)
        End If
    Else
        If KD Then SKboolFmt = "1" Else SKboolFmt = "0"
    End If
End Function

Function ULtoSPC(X$) As String
    ULtoSPC = X$
    i% = InStr(ULtoSPC, "_")
    While i% > 0
        ULtoSPC = Left$(ULtoSPC, i% - 1) + " " + Right$(ULtoSPC, Len(ULtoSPC) - i%)
        i% = InStr(ULtoSPC, "_")
    Wend
End Function

Function KeyData(SrcStr As String, IX As sle_IndexSet, Optional UpNest As Boolean = False)
    Dim Src As String, EchoFlag As Boolean, v1 As Single, v3 As Single
    '
    ' THIS FUNCTION IS RECURSIVE.  It can be re-entered through
    ' SKmultiFmt().
    '
    ' This takes the SrcStr and array IX of data array indeces as input,
    ' and returns the SrcStr with {keywords} replaced by data.  Those
    ' keywords may in turn indicate strings of type multiline, which
    ' will also be parsed recursively for keywords they might contain.
    '
    If UpNest = False Then
        'starting anew, prepare for nesting
        KeyNestLevel = 0
        'and save index set for SKmultiFmt to find
        KeyIX = IX
    Else
        KeyNestLevel = KeyNestLevel + 1
    End If
    If KeyNestLevel > 10 Then
        KeyData = Src 'do no conversion, out of stack space
        If UpNest Then KeyNestLevel = KeyNestLevel - 1
        Exit Function
    End If
    '
    EchoFlag = True
    Src = SrcStr
    KeyData = ""
    '
KDmore:
    i% = InStr(Src, "{")
    If i% = 0 Then
        'no more tags
        If EchoFlag Then KeyData = KeyData + Src
        If UpNest Then KeyNestLevel = KeyNestLevel - 1
        Exit Function
    End If
    'we have a tag
    If EchoFlag Then KeyData = KeyData + Left$(Src, i% - 1)
    Src = Right$(Src, Len(Src) - i%)
    i% = InStr(Src, "}")
    If i% = 0 Then
        'tag is unterminated
        If UpNest Then KeyNestLevel = KeyNestLevel - 1
        Exit Function
    End If
    'case preserved for tag with format
    kwd$ = Trim$(Left$(Src, i% - 1))
    'lowercase version used to process if/then/etc.
    kwl$ = LCase$(kwd$)
    Src = Right$(Src, Len(Src) - i%)
    '
    If kwl$ = "else" Then
        EchoFlag = Not EchoFlag
    ElseIf kwl$ = "endif" Then
        EchoFlag = True
    ElseIf kwl$ = "stop" Then
        If EchoFlag Then
           If UpNest Then KeyNestLevel = KeyNestLevel - 1
           Exit Function
        End If
    ElseIf Left$(kwl$ + "   ", 3) = "if " And Len(kwl$) > 3 Then
        k$ = Right$(kwl$, Len(kwl$) - 3)
        i% = InStr(k$, " ")
        If i% > 0 Then
            k1$ = Left$(k$, i% - 1)
            k$ = Right$(k$, Len(k$) - i%)
            i% = InStr(k$, " ")
            If i% > 0 Then
                k2$ = Left$(k$, i% - 1)
                k3$ = Trim$(Right$(k$, Len(k$) - i%))
                kx$ = KeySLE(k1$, IX)
                If kx$ = "" Then v3 = SingleVal(k1$) Else v1 = SingleVal(kx$)
                s1$ = Trim$(UCase$(kx$))
                kx$ = KeySLE(k3$, KeyIX)
                If kx$ = "" Then v3 = SingleVal(k3$) Else v3 = SingleVal(kx$)
                s3$ = Trim$(UCase$(kx$))
                Select Case k2$
                Case "=="
                    EchoFlag = (s1$ = s3$)
                Case "!="
                    EchoFlag = (s1$ <> s3$)
                Case "="
                    EchoFlag = (v1 = v3)
                Case "<>", "><"
                    EchoFlag = (v1 <> v3)
                Case ">"
                    EchoFlag = (v1 > v3)
                Case "<"
                    EchoFlag = (v1 < v3)
                Case ">=", "=<"
                    EchoFlag = (v1 >= v3)
                Case "<=", "=<"
                    EchoFlag = (v1 <= v3)
                Case Else
                    EchoFlag = True
                End Select
            End If
        End If
    Else
        If EchoFlag Then KeyData = KeyData + KeySLE(kwd$, IX)
    End If
    GoTo KDmore
End Function

Sub DefaultEditMenu()
    SLE_Edit.menuAct(0).Visible = True
    SLE_Edit.menuAct(0).Caption = "&Save"
    SLE_Edit.ActCMD(0).Visible = True
    SLE_Edit.ActCMD(0).Caption = "Save"
    If 1 > SLE_Edit.menuAct.UBound Then Load SLE_Edit.menuAct(1)
    SLE_Edit.menuAct(1).Visible = True
    SLE_Edit.menuAct(1).Caption = "&Quit"
    SLE_Edit.ActCMD(1).Visible = True
    SLE_Edit.ActCMD(1).Caption = "Quit"
End Sub

Sub DefaultDeleteMenu()
    If 2 > SLE_Edit.menuAct.UBound Then Load SLE_Edit.menuAct(2)
    SLE_Edit.menuAct(2).Visible = True
    SLE_Edit.menuAct(2).Caption = "&Delete"
    SLE_Edit.ActCMD(2).Visible = True
    SLE_Edit.ActCMD(2).Caption = "Delete"
End Sub

Sub AddEditMenu(i%, X$)
    If i% > SLE_Edit.menuAct.UBound Then Load SLE_Edit.menuAct(i%)
    SLE_Edit.menuAct(i%).Visible = True
    SLE_Edit.menuAct(i%).Caption = X$
    If i% <= 2 Then
        SLE_Edit.ActCMD(i%).Visible = True
        SLE_Edit.ActCMD(i%).Caption = StripAmp(X$)
    End If
End Sub

Sub ClearEditMenu()
    Call PlaceInit
    For i% = 0 To SLE_Edit.menuAct.UBound
        If i% > 0 Then SLE_Edit.menuAct(i%).Visible = False
    Next
    For i% = 0 To 2
        If i% > 0 Then SLE_Edit.ActCMD(i%).Visible = False
        SLE_Edit.ActCMD(i%).Caption = ""
    Next
End Sub

Function Timeout(ResetTime As Single, TimeoutVal As Single) As Boolean
    '
    'Returns TRUE if the timeoutval interval has
    'passed since the resettime was last set
    '
    Dim RT As Single, TV As Single
    '
    RT = ResetTime
    TV = Timer
    If RT > TV Then TV = TV + 86400 'timer wrapped around
    If TV < (RT + TimeoutVal) Then
        Timeout = False
    Else
        Timeout = True
    End If
    '
End Function


