Attribute VB_Name = "UDPcode"
Public Type One_System_Setup
    '
    UDPenabled As Boolean   ':UDP Enabled
    UDPserver As Boolean    ':UDP Server
    '=
    MyIP As String          ':My IP:___
    ExtIP As String         ':Other IP:
    Port As Long            ':Port:____
    '=
    TXinterval As Long      ':Auto Interval:
    TXautoMsg As Boolean    ':TX Auto Time:_
    '
    MyHostName As String    '*
    MyTrueIP As String      '*
    SockHandle As Integer   '*
    '
End Type

Public SD As One_System_Setup

'There has to be at least one array type for SLE to work
'
Public Type One_Set
    '
    Label As String
    Data As Long
    '
End Type
'
Public DS() As One_Set

'end gensle

' TCP/IP communication control structures
'
Dim StartupData As WSADataType
Dim DataPtr As Long
Dim DataReq As Long
Dim DataVal As Long

Dim MySockBuffer As sockaddr
Dim ExtSockBuffer As sockaddr

Public UDP_Client As sockaddr
Public UDP_Error As Long

Sub OnSaveSD()
    Dim PD As One_System_Setup
    If IsSDChanged(SD) Then
        Call WSACleanup
        PD = ReadEditSD()
        SD.UDPenabled = PD.UDPenabled
        SD.UDPserver = PD.UDPserver
        SD.MyIP = PD.MyIP
        SD.ExtIP = PD.ExtIP
        SD.Port = PD.Port
        SD.TXinterval = PD.TXinterval
        SD.TXautoMsg = PD.TXautoMsg
        Call SaveSD(SDPath)
        Call UDP_Init
    End If
    Call HideSLE_Edit
    Call EditingDone
End Sub

Function UDP_Init() As String
    '
    MainUI.Caption = "UDP Test"
    MainUI.UDPtimer.Enabled = False
    If Not SD.UDPenabled Then
        Call WSACleanup
        Exit Function
    End If
    '
    rc% = WSAStartup(&H101, StartupData)
    If rc% <> 0 Then
        UDPinit = "UDP Startup Error:" _
        + vbCr + GetWSAErrorString(rc%)
        Call WSACleanup
        Exit Function
    ElseIf StartupData.wVersion <> &H101 Then
        UDPinit = "UDP Version Error:" + Hex$(StartupData.wVersion)
        Call WSACleanup
        Exit Function
    End If
    '
    SD.SockHandle = socket(PF_INET, SOCK_DGRAM, 0)
    If SD.SockHandle = SOCKET_ERROR Then
        UDPinit = "UDP Could Not Create Host Socket."
        Call WSACleanup
        Exit Function
    End If
    
    'Make socket non-blocking
    DataVal = 1
    DataReq = FIONBIO
    DataPtr = ioctlsocket(SD.SockHandle, DataReq, DataVal)
    
    'Retrieve IP and hostname
    SD.MyHostName = GetLocalHostName
    If SD.MyIP <> "" Then
        SD.MyTrueIP = SD.MyIP
    Else
        SD.MyTrueIP = AddrToIP(SD.MyHostName)
    End If
    If SD.Port = 0 Then SD.Port = 12345
    '
    MySockBuffer.sin_family = AF_INET
    MySockBuffer.sin_port = htons(SD.Port)
    MySockBuffer.sin_addr = 0
    MySockBuffer.sin_zero = String$(8, 0)
    '
    If SD.UDPserver Then
        '
        'Bind host port for listening
        '
        rc% = bind(SD.SockHandle, MySockBuffer, sockaddr_size)
        If rc% = SOCKET_ERROR Then
            UDPinit = "UDP Host Socket Failed to Bind:" _
            + vbCr + GetWSAErrorString(Err.LastDllError)
            Call WSACleanup
            Exit Function
        End If
        'ExtSockBuffer gets filled out when we RecvFrom
        MainUI.Caption = "UDP Test Server"
        '
    Else
        '
        If SD.ExtIP = "" Then SD.ExtIP = "127.0.0.1"
        ExtSockBuffer.sin_family = AF_INET
        ExtSockBuffer.sin_port = htons(SD.Port)
        ExtSockBuffer.sin_addr = inet_addr(SD.ExtIP)
        ExtSockBuffer.sin_zero = String$(8, 0)
        MainUI.Caption = "UDP Test Client"
        '
    End If
    '
    'Success!
    '
    If SD.TXinterval > 0 Then
        MainUI.UDPtimer.Interval = SD.TXinterval
        MainUI.UDPtimer.Enabled = True
    End If
    UDPinit = ""
    '
End Function

Function UDP_Recv() As String
    '
    'Note that if we are a server, this sets the ExtSockBuffer
    'to direct all future replies to this message's source.
    '
    Dim MsgBuffer As String * 2050
    Dim BytesIn As Long
    Dim DataLen As Long
    Dim RData As String
    '
    BytesIn = recvfrom(SD.SockHandle, ByVal MsgBuffer, Len(MsgBuffer) - 2, 0, ExtSockBuffer, sockaddr_size)
    If BytesIn = SOCKET_ERROR Then
        UDP_Error = Err.LastDllError
    Else
        UDP_Recv = Left$(MsgBuffer, BytesIn)
        UDP_Client = ExtSockBuffer
        UDP_Error = BytesIn
    End If
    '
End Function

Sub UDP_Send(Msg As String)
    '
    'Note that if we are a server, this sends to the last client
    'from which we received a transmission.
    '
    Dim ByteBuf() As Byte
    Dim LbufLen As Long
    '
    LbufLen = Len(Msg)
    'Convert data to byte array
    ByteBuf() = StrConv(Msg, vbFromUnicode)
    'Send to socket
    UDP_Error = sendto(SD.SockHandle, ByteBuf(0), LbufLen, 0&, ExtSockBuffer, sockaddr_size)
    'Replace generic error with specific DLL error
    If UDP_Error = SOCKET_ERROR Then UDP_Error = Err.LastDllError
    '
End Sub

Sub UDP_Send_To(Msg As String, Client As sockaddr)
    '
    'If we are a server this allows us to reply to one of multiple clients.
    'To reply to a specific client, after receiving a message from them
    'cache the UDP_Client in a variable of type sockaddr and pass it to
    'this function as the Client argument.
    '
    Dim ByteBuf() As Byte
    Dim LbufLen As Long
    '
    LbufLen = Len(Msg)
    'Convert data to byte array
    ByteBuf() = StrConv(Msg, vbFromUnicode)
    'Send to socket
    UDP_Error = sendto(SD.SockHandle, ByteBuf(0), LbufLen, 0&, Client, sockaddr_size)
    'Replace generic error with specific DLL error
    If UDP_Error = SOCKET_ERROR Then UDP_Error = Err.LastDllError
    '
End Sub


